package betterwithmods.common.world.gen.village;

import betterwithmods.common.BWMBlocks;
import betterwithmods.module.hardcore.world.HCVillages;
import net.minecraft.block.BlockStairs;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;

import java.util.List;
import java.util.Random;

/**
 * Created by primetoxinz on 5/25/17.
 */
public class Butchery extends AbandonedVillagePiece {

    public Butchery() {
    }

    public Butchery(StructureVillagePieces.Start start, int type, Random rand, StructureBoundingBox p_i45567_4_, EnumFacing facing) {
        super(start, type);
        this.func_186164_a(facing);
        this.field_74887_e = p_i45567_4_;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(Butchery.class, 15, MathHelper.func_76136_a(random, 0 + size, 2 + size));
    }

    @Override
    public Class<?> getComponentClass() {
        return Butchery.class;
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 9, 7, 11, facing);
        return func_74895_a(structureboundingbox) && StructureComponent.func_74883_a(pieces, structureboundingbox) == null ? new Butchery(startPiece, p5, random, structureboundingbox, facing) : null;
    }

    public boolean func_74875_a(World worldIn, Random randomIn, StructureBoundingBox structureBoundingBoxIn) {
        if (this.field_143015_k < 0) {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);

            if (this.field_143015_k < 0) {
                return true;
            }

            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 7 - 1, 0);
        }
        IBlockState table = this.func_175847_a(BWMBlocks.WOOD_TABLE.func_176223_P());
        IBlockState iblockstate = this.func_175847_a(Blocks.field_150347_e.func_176223_P());
        IBlockState iblockstate1 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.NORTH));
        IBlockState iblockstate2 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.SOUTH));
        IBlockState iblockstate3 = this.func_175847_a(Blocks.field_150476_ad.func_176223_P().func_177226_a(BlockStairs.field_176309_a, EnumFacing.WEST));
        IBlockState iblockstate4 = this.func_175847_a(Blocks.field_150344_f.func_176223_P());
        IBlockState iblockstate5 = this.func_175847_a(Blocks.field_150364_r.func_176223_P());
        IBlockState fence = this.func_175847_a(Blocks.field_180407_aO.func_176223_P());
        IBlockState stoneslab = Blocks.field_150334_T.func_176223_P();

        IBlockState iblockstate7 = iblockstate1;
        IBlockState iblockstate8 = iblockstate2;
        if (HCVillages.disableAllComplexBlocks) {
            table = Blocks.field_150350_a.func_176223_P();
            iblockstate1 = iblockstate4;
            iblockstate2 = iblockstate4;
            iblockstate3 = iblockstate4;
            fence = Blocks.field_150350_a.func_176223_P();
            stoneslab = iblockstate;
        }
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 1, 1, 7, 4, 4, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 1, 6, 8, 4, 10, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 0, 6, 8, 0, 10, Blocks.field_150346_d.func_176223_P(), Blocks.field_150346_d.func_176223_P(), false);
        this.func_175811_a(worldIn, iblockstate, 6, 0, 6, structureBoundingBoxIn);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 2, 1, 6, 2, 1, 10, fence, fence, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 1, 6, 8, 1, 10, fence, fence, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 3, 1, 10, 7, 1, 10, fence, fence, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 1, 7, 0, 4, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 0, 3, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 8, 0, 0, 8, 3, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 0, 7, 1, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 5, 7, 1, 5, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 0, 7, 3, 0, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 2, 5, 7, 3, 5, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 4, 1, 8, 4, 1, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 4, 4, 8, 4, 4, iblockstate4, iblockstate4, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 5, 2, 8, 5, 3, iblockstate4, iblockstate4, false);
        this.func_175811_a(worldIn, iblockstate4, 0, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 0, 4, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 8, 4, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 8, 4, 3, structureBoundingBoxIn);


        for (int i = -1; i <= 2; ++i) {
            for (int j = 0; j <= 8; ++j) {
                this.func_175811_a(worldIn, iblockstate7, j, 4 + i, i, structureBoundingBoxIn);
                this.func_175811_a(worldIn, iblockstate8, j, 4 + i, 5 - i, structureBoundingBoxIn);
            }
        }

        this.func_175811_a(worldIn, iblockstate5, 0, 2, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 0, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 2, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate5, 8, 2, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 0, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 8, 2, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 3, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 5, 2, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 6, 2, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, table, 2, 1, 3, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate4, 1, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate7, 2, 1, 4, structureBoundingBoxIn);
        this.func_175811_a(worldIn, iblockstate3, 1, 1, 3, structureBoundingBoxIn);

        this.func_175804_a(worldIn, structureBoundingBoxIn, 5, 0, 1, 7, 0, 3, stoneslab, stoneslab, false);
        this.func_175811_a(worldIn, stoneslab, 6, 1, 1, structureBoundingBoxIn);
        this.func_175811_a(worldIn, stoneslab, 6, 1, 2, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 1, 0, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 2, 2, 0, structureBoundingBoxIn);
        this.func_189926_a(worldIn, EnumFacing.NORTH, 2, 3, 1, structureBoundingBoxIn);

        if (this.func_175807_a(worldIn, 2, 0, -1, structureBoundingBoxIn).func_185904_a() == Material.field_151579_a && this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_185904_a() != Material.field_151579_a) {
            this.func_175811_a(worldIn, iblockstate7, 2, 0, -1, structureBoundingBoxIn);

            if (this.func_175807_a(worldIn, 2, -1, -1, structureBoundingBoxIn).func_177230_c() == Blocks.field_185774_da) {
                this.func_175811_a(worldIn, Blocks.field_150349_c.func_176223_P(), 2, -1, -1, structureBoundingBoxIn);
            }
        }

        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 6, 1, 5, structureBoundingBoxIn);
        this.func_175811_a(worldIn, Blocks.field_150350_a.func_176223_P(), 6, 2, 5, structureBoundingBoxIn);
        this.func_189926_a(worldIn, EnumFacing.SOUTH, 6, 3, 4, structureBoundingBoxIn);

        for (int k = 0; k < 5; ++k) {
            for (int l = 0; l < 9; ++l) {
                this.func_74871_b(worldIn, l, 7, k, structureBoundingBoxIn);
                this.func_175808_b(worldIn, iblockstate, l, -1, k, structureBoundingBoxIn);
            }
        }

        this.func_74893_a(worldIn, structureBoundingBoxIn, 4, 1, 2, 1);
        return true;
    }

    protected int func_180779_c(int villagersSpawnedIn, int currentVillagerProfession) {
        return 4;
    }
}
